/**************
** IGUSTA'2' **
***************
ver.1.00   94/11/24   쵤˴
ver.1.01   95/08/03   äȤХȤ

by 

  _/__ ____ _/_         ãͺ   tatuo-y@is.aist-nara.ac.jp
  /___    / /__/_    üʳصر  ʳظ
 / ___   /    /___     عֺ(ܸ) 
                    http://cactus.aist-nara.ac.jp/student/tatuo-y

*/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/Cardinals.h>
#define W 8
#define H 8
#define LEFT 0
#define RIGHT 1
#define RANDOMIZE() srand(time(NULL))
#define RANDOM(x) (rand()%(x))
#define fx(x) (x/64)
#define fy(y) (y/64)
#define SQUARE(x) ((x)*(x))
#define NCOLORMODE 7 

/* ǡե֤λꡣɬ񤭴Ƥ͡*/
#define DATAFILE "/auto/home/is/tatuo-y/pub/igusta2/igu2.data"

static void QuitProc(),GameStart(),Uwagaki(),TrackPointer(),ReplayProc(),
    KaitenLeft(),Kaiten(),UndoProc(),ColorChange(),RankingWrite();

static unsigned long MyColor();

static Display *disp;
static GC gc1,gc2;

static char *ptr[6];
static unsigned long color[NCOLORMODE+1][6];
static int level = 0,colormode = 0;
static int fd[W][H],fkeep[W][H],frp[W][H],turn,score,scorekeep,mark_flag = 0;

static Widget toplevel,form,
    paned,quit_button,paned_label,new_game_button,level_menu,ranking_button,
    undo_button,replay_button,color_button,
    canvas,tracker,
    paned2,turn_L_button,turn_R_button;

static String level_select[]={"Level 1","Level 2","Level 3",};

static XtActionsRec actions[]={
    {"QuitProc",(XtActionProc)QuitProc},
    {"Uwagaki",(XtActionProc)Uwagaki},
    {"Kaiten",(XtActionProc)Kaiten},
    {"KaitenLeft",(XtActionProc)KaitenLeft},
    {"TrackPointer",(XtActionProc)TrackPointer},
};

static String fallback_resources[]={
    "*translations: #override\\n\
<Expose>: Uwagaki()\\n\
<Key>Q: QuitProc()",
    "*showGrip: off",
    "*paned.orientation: Horizontal",
    "*paned_label.label: Level:-  Score:---",
    "*quit_button.label: Quit",
    "*new_game_button.label: Game",
    "*new_game_button.menuName: level_menu",
    "*ranking_button.label: Ranking",
    "*undo_button.label: Undo",
    "*replay_button.label: Replay",
    "*color_button.label: Color",
    "*canvas.fromVert: paned",
    "*canvas.width: 512",
    "*canvas.height: 512",
    "*canvas.borderWidth: 3",
    "*canvas.cursor: arrow",
    "*canvas.translations: #override\\n\
<Btn1Down>: TrackPointer()\\n\
<Btn2Down>: KaitenLeft()\\n\
<Btn3Down>: Kaiten()\\n\
<Motion>: TrackPointer()",
    "*paned2.fromVert: canvas",
    "*paned2.orientation: Horizontal",
    "*turn_L_button.label: Turn Left",
    "*turn_R_button.label: Turn Right",
    NULL,
};


SetAppData() /*  */
{
/* ֥åΥѥǡ */
    static char data1[] ={ 0xFF,0xFF,0xFF,0xFF };
    static char data2[] ={ 0x55,0xAA,0x55,0xAA };
    static char data3[] ={ 0x55,0x22,0x55,0x88 };
    static char data4[] ={ 0x11,0x44,0x11,0x44 };
    static char data5[] ={ 0xFF,0x00,0xFF,0x00 };
    int i,j;

    disp = XtDisplay(toplevel);
    gc1 = XCreateGC(disp,RootWindow(disp,0),0,NULL);
    gc2 = XCreateGC(disp,RootWindow(disp,0),0,NULL);

    ptr[1]=data1;ptr[2]=data2;ptr[3]=data3;ptr[4]=data4;ptr[5]=data5;

/* ֥åΥ顼ǡ */
    color[1][1] = MyColor( disp, "red" );color[1][2] = MyColor( disp,"blue" );
    color[1][3] = MyColor(disp,"green");color[1][4] = MyColor(disp,"violet" );
    color[1][5] = MyColor( disp, "orange" );
    color[2][1] = MyColor( disp, "LightPink1" );
    color[2][2] = MyColor( disp, "cyan" );
    color[2][3] = MyColor( disp, "yellow" );
    color[2][4] = MyColor( disp, "green" );
    color[2][5] = MyColor( disp, "orchid1" );
    color[3][1] = MyColor( disp, "peachpuff" );
    color[3][2] = MyColor( disp, "lavender" );
    color[3][3] = MyColor( disp, "honeydew" );
    color[3][4] = MyColor( disp, "lemon chiffon" );
    color[3][5] = MyColor( disp, "gainsboro" );
    color[4][1] = MyColor( disp, "red3" );
    color[4][2] = MyColor( disp, "goldenrod3" );
    color[4][3] = MyColor( disp, "navy" );
    color[4][4] = MyColor( disp, "darkgreen" );
    color[4][5] = MyColor( disp, "magenta3" );
    color[5][1] = MyColor( disp, "black" );
    color[5][2] = MyColor( disp, "gray63" );
    color[5][3] = MyColor( disp, "light gray" );
    color[5][4] = MyColor( disp, "dim gray" );
    color[5][5] = MyColor( disp, "gray93" );
    color[6][1] = MyColor( disp, "green" );
    color[6][2] = MyColor( disp, "dark green" );
    color[6][3] = MyColor( disp, "DarkSeaGreen1" );
    color[6][4] = MyColor( disp, "OliveDrab1" );
    color[6][5] = MyColor( disp, "medium sea green" );
    color[7][1] = MyColor( disp, "chocolate1" );
    color[7][2] = MyColor( disp, "sienna4" );
    color[7][3] = MyColor( disp, "khaki2" );
    color[7][4] = MyColor( disp, "yellow3" );
    color[7][5] = MyColor( disp, "rosy brown" );

    XSetForeground(disp,gc1,BlackPixel(disp,0));
    XSetForeground(disp,gc2,0xffffffff);
    XSetBackground(disp,gc1,WhitePixel(disp,0));
    XSetFunction(disp,gc2,GXxor);

    XSetFillStyle(disp,gc1,FillOpaqueStippled);
    XSetLineAttributes( disp, gc1, 1, LineSolid, CapRound,JoinRound );
    
    for( i = 0; i < W; i++)for( j = 0; j < H; j++) fd[i][j]=0;
}

OptionHandler(argc,argv) /* ץν */
int argc;
char **argv;
{
    char sw;
    if( argc > 1 )
        while(--argc)
	{
            if( *argv[argc] == '-' )
                while( sw = *( ++argv[argc]))
                {
                    if(sw == 'c') 
			if((sw = *( ++argv[argc]))>='0'&& sw <='9')
			    {colormode = sw-'0';
			     if(colormode>NCOLORMODE)colormode=0;}
			else {colormode = 1;argv[argc]--;}
                    else if(sw == 'r'){RankingWrite();exit(1);}
		    else{UsageWrite();exit(0);}
                }
            else{UsageWrite();exit(0);}
        }
}

UsageWrite()
{
    printf("\nIGUSTA2 ver.1.01  95/8/3\n");
    printf("\tby YAMASITA Tatuo ( tatuo-y@is.aist-nara.ac.jp )\n\n");
    printf("Valid Options are:\n\t-c[0-%d] : Color Mode\n",NCOLORMODE);
    printf("\t-r : Score Ranking\n\n");
    printf("manual is at http://cactus.aist-nara.ac.jp/student/tatuo-y/igusta.html\n\n");
}

main(argc,argv)
int argc;
char **argv;
{
    XtAppContext app_con;
    Widget entry;
    int i;

    OptionHandler(argc,argv);
    toplevel = XtVaAppInitialize(&app_con,"igusta2",NULL,ZERO,&argc,argv,
				 fallback_resources,NULL);
    SetAppData();

    form = XtVaCreateManagedWidget("form",formWidgetClass,toplevel,NULL);

    paned = XtVaCreateManagedWidget("paned",panedWidgetClass,form,NULL);
    paned_label = XtVaCreateManagedWidget("paned_label",
					  labelWidgetClass,paned,NULL);
    quit_button = XtVaCreateManagedWidget("quit_button",commandWidgetClass,
					  paned,NULL);
    new_game_button = XtVaCreateManagedWidget("new_game_button",
					     menuButtonWidgetClass,paned,NULL);
    level_menu = XtVaCreatePopupShell("level_menu",simpleMenuWidgetClass,
				      new_game_button,NULL);
    for(i=0;(int)XtNumber(level_select)>i;i++){
	entry = XtVaCreateManagedWidget(level_select[i],smeBSBObjectClass,
					level_menu,NULL);
	XtAddCallback(entry,XtNcallback,GameStart,i+1);
    }
    ranking_button = XtVaCreateManagedWidget("ranking_button",
					     commandWidgetClass,paned,NULL);
    undo_button = XtVaCreateManagedWidget("undo_button",
					  commandWidgetClass,paned,NULL);
    replay_button = XtVaCreateManagedWidget("replay_button",
					     commandWidgetClass,paned,NULL);
    color_button = XtVaCreateManagedWidget("color_button",
					     commandWidgetClass,paned,NULL);

    canvas = XtVaCreateManagedWidget("canvas",widgetClass,form,NULL);

    paned2 = XtVaCreateManagedWidget("paned2",panedWidgetClass,form,NULL);
    turn_L_button = XtVaCreateManagedWidget("turn_L_button",commandWidgetClass,
					  paned2,NULL);
    turn_R_button = XtVaCreateManagedWidget("turn_R_button",commandWidgetClass,
					  paned2,NULL);


    XtAppAddActions(app_con,actions,XtNumber(actions));
    XtAddCallback(quit_button,XtNcallback,QuitProc,canvas);
    XtAddCallback(undo_button,XtNcallback,UndoProc,canvas);
    XtAddCallback(replay_button,XtNcallback,ReplayProc,canvas);
    XtAddCallback(color_button,XtNcallback,ColorChange,canvas);
    XtAddCallback(ranking_button,XtNcallback,RankingWrite,canvas);
    XtAddCallback(turn_L_button,XtNcallback,Kaiten,LEFT);
    XtAddCallback(turn_R_button,XtNcallback,Kaiten,RIGHT);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_con);
}

static void RankingWrite() /* 󥭥ɽ */
{
    int sc,tr,yr,mn,dy,hr,i,j;
    char nm[10];
    FILE *fp;
    if((fp = fopen(DATAFILE,"r")) == NULL){
	printf("File Open ERR. I can't read score-file. Or there is no score-file.\n");}
    else{
      for(i = 0;i < 3;i++){
	printf("\nLEVEL %d\n",i+1);
	printf("    score     name      date\n");
	for(j = 0;j < 10;j++){
	  fscanf(fp,"%d %d %s %d %d %d %d\n",&sc,&tr,nm,&yr,&mn,&dy,&hr);
	  printf("%2d   %3d  [ %8s ]  %2d/%2d/%2d %2d:%2d\n"
		 ,j+1,sc,/*tr,*/nm,yr,mn,dy,hr/100,hr%100);
	}
      }
      fclose(fp);
    }
}

static void ColorChange(w) /* ֥åοѹ */
Widget w;
{
    colormode = (colormode + 1) % (NCOLORMODE + 1);
    Hyouji();
}

static void UndoProc(w)
Widget w;
{
    int i,j,t;
    t=0;for(i=0;i<W;i++)t+=fd[i][H-1];
    if(t){
	for( i = 0; i < W; i++)for( j = 0; j < H; j++)fd[i][j]=fkeep[i][j];
	score = scorekeep;}
    mark_flag = 0;ScoreWrite();Hyouji();
}

static void ReplayProc(w)
Widget w;
{
    int i,j;
    for( i = 0; i < W; i++)for( j = 0; j < H; j++)fd[i][j]=frp[i][j];
    score = 0;mark_flag = 0;
    ScoreWrite();Hyouji();
}

static void QuitProc(w)
Widget w;
{
    exit(1);
}

static void Kaiten(w,d) /* ž */
Widget w;
int d;
{
    int i,j,fdk[W][H];
    Keep();mark_flag = 0;
    for(i=0;i<W;i++)for(j=0;j<H;j++)
	if(d)fdk[7-j][i]=fd[i][j];
	else fdk[j][7-i]=fd[i][j];
    for(i=0;i<W;i++)for(j=0;j<H;j++)fd[i][j]=fdk[i][j];
    Hyouji();
    for(i=0;i<W-1;i++){Down();Hyouji();}
}

static void KaitenLeft(w) /* ޥΥܥǺžκ */
Widget w;
{
  Kaiten(w,0);
}

static void Uwagaki(w)
Widget w;
{
    Hyouji();mark_flag = 0;
}

static void GameStart(w,l)
Widget w;
int l;
{
    score = 0; turn = 0; mark_flag = 0;
    DataMake(level = l);
    Hyouji();
    ScoreWrite();
}


static void TrackPointer(w,ev)
Widget w;
XEvent *ev;
{
    static int sta_x,sta_y;
    int x,y;

    x = ev->xmotion.x; y = ev->xmotion.y; 
    switch(ev->type){
    case ButtonPress:

	switch(mark_flag){
	case 0:
	    mark_flag = 1;
	    sta_x = x; sta_y = y;
	    XSetForeground(disp,gc1,WhitePixel(disp,0));
	    XFillRectangle(XtDisplay(w),XtWindow(w),gc1,
			   fx(x)*64+16,fy(y)*64+16,32,32);
	    XSetForeground(disp,gc1,BlackPixel(disp,0));
	    XFillRectangle(XtDisplay(w),XtWindow(w),gc1,
			   fx(x)*64+20,fy(y)*64+20,24,24);
	    break;
	case 1:
	    mark_flag = 0;
	    CheckAndGet(fx(x),fy(y),fx(sta_x),fy(sta_y));
	    Hyouji();
	    break;
	}
    }

}

CheckAndGet(x,y,xa,ya)
int x,y,xa,ya;
{
    int i,t;

    if( y!=ya || x==xa || fd[x][y]==0 || fd[xa][ya]==0 )return(0);
    if( x > xa ){ t = x; x = xa; xa = t;}
    t = fd[x][y];
    for(i=x;i<=xa;i++)if( t != fd[i][y] )return(0);
    Keep();
    for(i=x;i<=xa;i++)fd[i][y]=0;
    score += SQUARE(xa-x+1);
    ScoreWrite();
    Down();
    t=0;for(i=0;i<W;i++)t+=fd[i][H-1];
    if(t==0)Clear();
}

Clear() /* ꥢν */
{
    char str[50],no[4],a='t',b='h';
    int rank;
    printf("********************\n");
    printf("* Congratulations! *\n");
    printf("********************\n");
    sprintf(str,"Clear! < %d >",score);
	/*      "Level:-  Score:---" */
    
    switch(rank = Filer()){
    case 0: /* 󥯥󤷤ʤä */
	break;
    case 11: /* 顼 */
	printf("File Open ERR. I can't read score-file. Or there is no score-file.\n");
	break;
    case 12: /* 顼 */
	printf("File Open ERR. I can't write to score-file.\n");
	break;
    default : /* 󥯥󤷤*/
	sprintf(no,"%d%c%c",rank,a,b);
	sprintf(str,"%4s Prize!  :%3d",no,score);
    }
    XtVaSetValues(paned_label,XtNlabel,str,NULL);
}

int Filer() /* ǡեν񤭹 */
{
    struct tm *lt;
    long time_t t;
    FILE *fp;
    int sc[3][11],tr[3][11],yr[3][11],mn[3][11],dy[3][11],hr[3][11],
        sctmp,trtmp,yrtmp,mntmp,dytmp,hrtmp;
    int i,j,k,count = 0,keep,rank = 0;
    char nm[3][11][10], *un,tmp;

    t = time((time_t *)0);
    lt = localtime(&t);

    if((fp = fopen(DATAFILE,"r")) == NULL)return(11);/* Read Error */
    for(i = 0;i < 3;i++)
        for(j = 0;j < 10;j++){
            fscanf(fp,"%d %d %s %d %d %d %d\n",&sc[i][j],&tr[i][j],nm[i][j],
                   &yr[i][j],&mn[i][j],&dy[i][j],&hr[i][j]);}
    fclose(fp);

    if((fp = fopen(DATAFILE,"w")) == NULL)return(12);/* Write Error */
    for(i = 0; i < 3; i++)
    {
	j = 0; k = 0;
	while(k < 10)
	    if(i != level-1){
		fprintf(fp,"%d %d %s %d %d %d %d\n",sc[i][j],tr[i][j],
			nm[i][j],yr[i][j],mn[i][j],dy[i][j],hr[i][j]);
		j++; k++;}
	    else{
		if((sc[i][j]<score)&&(rank==0)&&(count<3)){
		    fprintf(fp,"%d %d %s %d %d %d %d\n",score,
			    score,getenv("USER"),lt->tm_year,
			    lt->tm_mon+1,lt->tm_mday,
			    (lt->tm_hour)*100 + lt->tm_min);
		    rank = k+1;
		    count++; k++;}
		else {
		    if(strcmp(nm[i][j],getenv("USER"))==0){
			count++;
			if(count>3)j++;}
		    fprintf(fp,"%d %d %s %d %d %d %d\n",sc[i][j],tr[i][j],
			    nm[i][j],yr[i][j],mn[i][j],dy[i][j],hr[i][j]);
		    j++; k++;}
	    }
    }
    fclose(fp);return(rank);
}

Keep() /* Undo Τ˥ǡ¸롣*/
{ 
    int i,j;
    for( i = 0; i < W; i++)for( j = 0; j < H; j++)fkeep[i][j]=fd[i][j];
    scorekeep = score;
}

ScoreWrite() /* ߤɽ */
{
    char str[50];
    sprintf(str,"Level:%d  Score:%3d",level,score);
    XtVaSetValues(paned_label,XtNlabel,str,NULL);
} 

static unsigned long MyColor(display,color)
Display *display;
char *color;
{
    Colormap camp;
    XColor c0,c1;

    camp = DefaultColormap(display,0);
    XAllocNamedColor(display,camp,color,&c1,&c0);
    return(c1.pixel);
}

Hyouji() /* ֥åɽ */
{
    Widget w = canvas;
    int i,j,x,y;

    XSetLineAttributes( disp, gc1, 1, LineSolid, CapRound,JoinRound );

    for( j = 0; j < H; j++)
    {
        for( i = 0; i < W; i++)
        {
	    XSetForeground( disp, gc1, BlackPixel( disp, 0 ) );
	    XSetStipple(disp,gc1,
		XCreateBitmapFromData(XtDisplay(w),XtWindow(w),ptr[1],8,4));
            x = i*64; y = j*64;
            if(fd[i][j])
            {   
		if(colormode)XSetForeground(disp,gc1,
					    color[colormode][fd[i][j]]);
		else {XSetStipple(disp,gc1,
			     XCreateBitmapFromData(XtDisplay(w),XtWindow(w),
						       ptr[fd[i][j]],8,4));}
		XFillRectangle(XtDisplay(w),XtWindow(w),gc1,x+1,y+1,62,62);
	    }
            else{
                XSetForeground(disp,gc1,WhitePixel(disp,0));
                XFillRectangle(XtDisplay(w),XtWindow(w),gc1,x,y,64,64);
	    }
        }
    }
    XSetStipple(disp,gc1,
		XCreateBitmapFromData(XtDisplay(w),XtWindow(w),ptr[1],8,4));
    XSetBackground( disp, gc1, WhitePixel( disp, 0 ) );
    return(1);
}

Down() /* Down all blocks */
{
    int i,j;
    for( i = 0; i < W; i++)
        for( j = H-1; j > 0; j--)
            if(fd[i][j]==0){
                fd[i][j]=fd[i][j-1]; fd[i][j-1]=0;
            }
    return(1);
}

DataMake(l) /* ֥åν֤ꤹ롣*/
int l;
{
    int i,j,tx,ty;
    score = 0; turn = 0;

    RANDOMIZE();
    for( i = 0; i < W; i++)
	for( j = 0; j < H; j++) fd[i][j]=fkeep[i][j]=frp[i][j]=1;
    for( i = 0; i <= l; i++)
	for( j = 0; j < W*H/(l+2); j++)
	{
	    while(fd[tx=RANDOM(1001)%8][ty=RANDOM(1001)%8]!=1);
	    fd[tx][ty]=fkeep[tx][ty]=frp[tx][ty]=i+2;
	}
    return(1);
}
